                {SOREL(C)  S.-Petersburg}
              {e-mail: delphimanx@rambler.ru }



unit UnitL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OpenGL, ExtCtrls, StdCtrls, Menus, Buttons, IniFiles, Math;


type
 TPoint3 = record
            x: ShortInt;
            y: ShortInt;
            c: ShortInt;
           end;

type
 TArrayP3 = array of TPoint3;

type
 TArrayB = array of byte;

type
 TArray4 = array [0..3] of GlFloat;

type
 TArray4B = array [1..4] of ShortInt;


type
 TArray2 = array [0..8,0..8] of ShortInt;

type
 TArray2P = array [0..8,0..8] of TPoint;

type
 TArray1 = array of Integer;

type
 TArray2D = array of array of Integer;

type
 TPreview = array [0..2] of ShortInt;

type
 TWField = record
           Field: TArray2;
           Preview: TPreview;
           Points:  Integer;
          end;

type
 TMatProperty = record
            ambient:  TArray4;
            diffuse:  Tarray4;
           specular:  TArray4;
           emission:  TArray4;
          shininess:  GlFloat;
     lmodel_ambient: array[0..3] of GLfloat
                end;




type
  TfrmGL = class(TForm)
    P1: TPanel;
    Panel1: TPanel;
    Back: TButton;
    Right: TButton;
    Panel2: TPanel;
    PFLD: TPanel;
    Pv: TPanel;
    Panel3: TPanel;
    SBSave: TSpeedButton;
    SBLoad: TSpeedButton;
    SBNew: TSpeedButton;
    Label1: TLabel;
    PW: TPanel;
    Label2: TLabel;
    PP: TPanel;
    OpenFile: TOpenDialog;
    SaveFile: TSaveDialog;




    // Public declarations }


    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure Tm1Timer(Sender: TObject);
    procedure Tm2Timer(Sender: TObject);
    procedure DrawLine(x1,y1,x2,y2,dl: GLINT);
    procedure GetInnerCoord(x1,y1: Integer; var x2,y2: GLFloat);
    procedure CreateField;
    procedure CreateCoord;
    procedure DrawSphere(x,y: Integer);
    procedure ClearSquare(x,y: Integer);
    procedure PFLDMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BackClick(Sender: TObject);
    procedure RightClick(Sender: TObject);
    procedure SBNewClick(Sender: TObject);
    procedure SBSaveClick(Sender: TObject);
    procedure SBLoadClick(Sender: TObject);
  


  private
  DC,DC1: HDC;
  hrc,hrc1: HGLRC;
  hnd,hnd1: THandle;


  public
   L_Size: Integer; // 
     Field,  Field_C, Way: TArray2; //,  ,  , -  . 
     BackField: TArray2; //for |<<|
     _Width,_Height: Cardinal;
    BuffField: TArrayB;
     XPos,YPos,NCPos,Min_Out: Integer;
    MatSphere: array of TMatProperty;
    Preview: TPreview;

    F_Points,JumpSpeed,DeleteSpeed,MoveSpeed,Winner,SaveAll,DisMoveDelay,Smooth: Cardinal;
    F_CurrentField, F_RightPos, F_Pos, F_NumberFields,
    F_BackShift, F_BackPos, F_BackNum, F_BackPoint: Integer; //for |<<|
    F_Rad,MinLevel,MaxLevel,MaxScale: GLFloat;
    FS_Field: TFileStream;
    IniList: TStringList;
    BuffS: TArrayB;
    F_Pt,F_BPos: Byte;
    DUS: TArrayB;

    procedure GetPossibleMoves(x,y: Integer; var AX,AY: TArray1; var BH: Boolean);
    procedure GetNearestMove(xn,yn: Integer; AX,AY: TArray1; var x,y: Integer);
    procedure CanMove(x1,y1,xn,yn: Integer; var WX,WY: TArray1; var BH: Boolean);
    procedure FindNearestSame(x,y,dx,dy: Integer; var N: Integer);
    procedure NewGame;
    procedure ShowField;
    procedure FindRemove(x,y: Integer; var AX,AY: TArray1);
    procedure RemoveSphere(AX,AY: TArray1);
    procedure glutSolidSphere(Radius : GLdouble;Slices : GLint;Stacks : GLint);
    procedure SetLightPos;
    procedure SetMaterial(nc: Integer);
    procedure CopyField;
    procedure RandomSphere(var x,y,nc: Integer);
    procedure RandomPreview;
    procedure Idle(Sender: TObject; var Done: Boolean);
    procedure MoveSphere(x1,y1,x2,y2: Integer);
    procedure AddPoints(N: Integer);
    function  CheckEndGame: Boolean;
    procedure DeleteSphere(AX,AY: TArray1);
    procedure ShowPreview;
    procedure DrawSpherePv(x,y: Integer);
    procedure ShowDisableMove(x,y: Integer);
    procedure WriteField(Name: String);
    procedure ReadField(Name: String);
    //procedure IntToByte(N: Integer; var AB: TArrayB);
    //function  ByteToInt(Buff: TArrayB; i: Integer): Integer;
    function  ReadIni: Boolean;
    procedure SaveIni;

    procedure InitField;
    procedure AddBuff(x,y,nc: Byte);
    procedure Pack;
    procedure Unpack(N: Integer);

    procedure TestPack_Unpack;
    procedure CompareField(i,j: Integer; var N,Pt: Integer);
    procedure GetBackPos(Pos: Integer);







    //procedure ShowM1(AX,AY: TArray1);
    //procedure ShowM2;










  end;



var
  frmGL: TfrmGL;
  Sc,ds,dx,RY: Single;
  F_UpDown,F_CompStrch: Integer;
  Buff,Buff1: TBitMap;
  Rec:TRect;
  quadObj : GLUquadricObj;

  Coord,CoordSc: TArray2P;
  Buff2: array [0..65,0..65,0..2] of GLUBYTE;
  _R,_G,_B: GLFLOAT;
  fds: GLFloat;
  L1_Ambient: TArray4;
  L1_Diffuse: TArray4;
  L1_Specular: TArray4;
  L0_Ambient: TArray4;
  L0_Diffuse: TArray4;
  L0_Specular: TArray4;
  Lpos,Lpos1: array [0..3] of GLFloat;
  B_Jump: Boolean;
  MMTimer : uint;
  //
  WField: array of TWField;
  F_Test: Integer;


implementation


{$R *.DFM}


procedure TFrmGl.glutSolidSphere(Radius : GLdouble;Slices : GLint;Stacks : GLint);
begin { glutSolidSphere }
  if quadObj = nil then
    quadObj := gluNewQuadric;
  gluQuadricDrawStyle(quadObj, GLU_FILL);
  gluQuadricNormals(quadObj, GLU_SMOOTH);
  gluSphere(quadObj, Radius, Slices, Stacks);
end; { glutSolidSphere }


procedure TFrmGl.CreateCoord;
var
i,j,ds,x0,y0,xs,ys: Integer;
begin
ds:=54; x0:=29; y0:=29;
xs:=3; 
  for i:=0 to 8 do
  begin
   y0:=29;
   xs:=3+(52+2)*(i);
   for j:=0 to 8 do
   begin
    ys:=3+(52+2)*(8-j);
    Coord[i,j].x:=x0;
    Coord[i,j].y:=y0;
    CoordSc[i,j].x:=xs;
    CoordSc[i,j].y:=ys;
    y0:=y0+ds;
   end;
   x0:=x0+ds;
  end;


 //glScissor(0,435,_Width-440,_Height);

end;


procedure TFrmGl.CreateField;
var
SF,DL,i,x: Integer;
begin
 glDisable(GL_DEPTH_TEST);
 glDisable(GL_LIGHTING);
 glClearColor (0.75, 0.75, 0.75, 1.0);
 glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);


 //glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 //glClearColor(0.75,0.75,0.75,1);


 DL:=2; SF:=52;
 DrawLine(-1,-1,491,-1,3);
 DrawLine(490,-1,490,491,3);
 DrawLine(0,490,490,490,3);
 DrawLine(1,491,1,1,3);

 x:=3;
 for i:=1 to 8 do
 begin
  x:=x+SF+2;
  //x:=i*SF+(i-1)*DL+3;
  DrawLine(x-1,0,x-1,490,2);
  DrawLine(0,x,490,x,2);
 end;

 SwapBuffers(DC);

 glEnable(GL_DEPTH_TEST);
 glEnable(GL_LIGHTING);
end;


procedure TfrmGL.GetInnerCoord(x1,y1: Integer; var x2,y2: GLFloat);
var
 Viewport : Array [0..3] of GLInt;
 mvMatrix, ProjMatrix : Array [0..15] of GLDouble;
 RealY : GLint ;          //  OpenGL y - 
 wx, wy, wz : GLdouble ;  //   x, y, z 
 Zval : GLfloat;
begin


 glGetIntegerv (GL_VIEWPORT, @Viewport);
 glGetDoublev (GL_MODELVIEW_MATRIX, @mvMatrix);
 glGetDoublev (GL_PROJECTION_MATRIX, @ProjMatrix);
 // viewport[3] -    
 RealY := viewport[3] - Y1 - 1;
 {Caption := '  ' + IntToStr (x) + ' ' +
            FloatToStr (RealY);}

 glReadPixels(X1, RealY, 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, @Zval);

 gluUnProject (X1, RealY, Zval,
                @mvMatrix, @ProjMatrix, @Viewport, wx, wy, wz);

 {ShowMessage ('   z=' + FloatToStr(Zval)
              + ' : ' + chr (13) + '(' + FloatToStr(wx)
              + '; ' + FloatToStr(wy)
              + '; ' + FloatToStr(wz) + ')');}

 x2:=wx; y2:=wy;
end;


procedure TFrmGl.DrawLine(x1,y1,x2,y2,dl: GLINT);
var
wx1,wx2,wy1,wy2: GLFloat;
begin
 GetInnerCoord(x1,y1,wx1,wy1);
 GetInnerCoord(x2,y2,wx2,wy2);
 glColor3f(0,0,0);
 glLineWidth(dl);
 glBegin(GL_LINES);
  glVertex2f(wx1,wy1);
  glVertex2f(wx2,wy2);
 glEnd;
end;




{=======================================================================
 }
procedure TfrmGL.FormPaint(Sender: TObject);
const
    no_mat              : array[0..3] of GLfloat = ( 0.0, 0.0, 0.0, 1.0 );
    mat_ambient         : array[0..3] of GLfloat = ( 0.7, 0.7, 0.7, 1.0 );
    mat_ambient_color   : array[0..3] of GLfloat = ( 0.8, {0.8}1.0, 0.2, 1.0 );
    mat_diffuse         : array[0..3] of GLfloat = ( 0.1, 0.5, 0.8, 1.0 );
    mat_specular        : array[0..3] of GLfloat = ( 1.0, 1.0, 1.0, 1.0 );
    no_shininess        : array[0..0] of GLfloat = ( 0.0 );
    low_shininess       : array[0..0] of GLfloat = ( 5.0 );
    high_shininess      : array[0..0] of GLfloat = ( 100.0 );
    mat_emission        : array[0..3] of GLfloat = ( 0.1, 0.5, 0.1, 1.0 );


    var
    Nt,i,j: Integer;
    pos,pos1: array [0..3] of GLFloat;
    fogCl: array [0..3] of GLFloat;
    TX,TY,sx1,sx2,sy1,sy2: GLFloat;
begin
  PFLD.Update;
  SwapBuffers(DC);

  Pv.Update;
  wglMakeCurrent(0,0);
  wglMakeCurrent(DC1, hrc1);
  SwapBuffers(DC1);

  wglMakeCurrent(0,0);
  wglMakeCurrent(DC, hrc);
end;


procedure SetDCPixelFormat (hdc : HDC);
var
 pfd : TPixelFormatDescriptor;
 nPixelFormat : Integer;
begin
 FillChar (pfd, SizeOf (pfd), 0);
 pfd.dwFlags  := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
 nPixelFormat := ChoosePixelFormat (hdc, @pfd);
 SetPixelFormat (hdc, nPixelFormat, @pfd);

end;


function TFrmGl.ReadIni: Boolean;
begin
ReadIni:=True;
IniList:=TStringList.Create;
try
  IniList.LoadFromFile('Lines.ini');
  Winner:=StrToInt(IniList.Values['Winner']);
  DeleteSpeed:=StrToInt(IniList.Values['DeleteSpeed']);
  F_Rad:=StrToFloat(IniList.Values['Radius']);
  MinLevel:=StrToFloat(IniList.Values['JumpDown']);
  MaxLevel:=StrToFloat(IniList.Values['JumpUp']);
  MaxScale:=StrToFloat(IniList.Values['JumpDeep']);
  JumpSpeed:=StrToInt(IniList.Values['JumpSpeed']);
  MoveSpeed:=StrToInt(IniList.Values['MoveSpeed']);
  SaveAll:=StrToInt(IniList.Values['SaveAll']);
  DisMoveDelay:=StrToInt(IniList.Values['DisMoveDelay']);
  Smooth:=StrToInt(IniList.Values['Smooth']);
except
 ReadIni:=False;
end;
IniList.Free;
end;


procedure TFrmGl.SaveIni;
begin
IniList:=TStringList.Create;
IniList.Add('Winner='+IntToStr(Winner));
IniList.Add('DeleteSpeed='+IntToStr(DeleteSpeed));
IniList.Add('Radius='+FloatToStr(F_Rad));
IniList.Add('JumpDown='+FloatToStr(MinLevel));
IniList.Add('JumpUp='+FloatToStr(MaxLevel));
IniList.Add('JumpDeep='+FloatToStr(MaxScale));
IniList.Add('JumpSpeed='+IntToStr(JumpSpeed));
IniList.Add('MoveSpeed='+IntToStr(MoveSpeed));
IniList.Add('SaveAll='+IntToStr(SaveAll));
IniList.Add('DisMoveDelay='+IntToStr(DisMoveDelay));
IniList.Add('Smooth='+IntToStr(Smooth));
try
IniList.SaveToFile('Lines.ini');
finally
IniList.Free;
end;
end;




procedure TfrmGL.FormCreate(Sender: TObject);
var
    i,j: Integer;
    AB: TArrayb;
begin


  CreateCoord;


 L1_Ambient [0] := 0.0;
 L1_Ambient [1] := 0.0;
 L1_Ambient [2] := 0.0;
 L1_Ambient [3] := 1.0;

 L1_Diffuse [0] := 0.1;
 L1_Diffuse [1] := 0.1;
 L1_Diffuse [2] := 0.1;
 L1_Diffuse [3] := 1.0;

 L1_Specular [0] := 0.7;
 L1_Specular [1] := 0.7;
 L1_Specular [2] := 0.7;
 L1_Specular [3] := 1.0;



 L0_Ambient [0] := 0.05;
 L0_Ambient [1] := 0.05;
 L0_Ambient [2] := 0.05;
 L0_Ambient [3] := 1.0;

 L0_Diffuse [0] := 1.0;
 L0_Diffuse [1] := 1.0;
 L0_Diffuse [2] := 1.0;
 L0_Diffuse [3] := 1.0;

 L0_Specular [0] := 1.0;
 L0_Specular [1] := 1.0;
 L0_Specular [2] := 1.0;
 L0_Specular [3] := 1.0;



 hnd:=PFLD.Handle;
 DC := GetDC (hnd);
 SetDCPixelFormat(DC);
 hrc := wglCreateContext(DC);
 wglMakeCurrent(DC, hrc);

 hnd1:=Pv.Handle;
 DC1 := GetDC (hnd1);
 SetDCPixelFormat(DC1);
 hrc1 := wglCreateContext(DC1);
 


 glEnable(GL_DEPTH_TEST);
 glEnable(GL_LIGHTING);
 glEnable(GL_LIGHT0);
 glEnable(GL_LIGHT1);

 glLightfv(GL_LIGHT1, GL_AMBIENT,  @L1_Ambient);
 glLightfv(GL_LIGHT1, GL_DIFFUSE,  @L1_Diffuse);
 glLightfv(GL_LIGHT1, GL_SPECULAR, @L1_Specular);


 glLightfv(GL_LIGHT0, GL_AMBIENT,  @L0_Ambient);
 glLightfv(GL_LIGHT0, GL_DIFFUSE,  @L0_Diffuse);
 glLightfv(GL_LIGHT0, GL_SPECULAR, @L0_Specular);







 Sc:=0;
 ds:=0.05;
 dx:=0.05;
 RY:=0;
 F_UpDown:=2;    //1-up,2-down
 F_CompStrch:=0; //1-comp,2-strch,0-nothing
 fds:=0;
 Min_Out:=5;

 SetLightPos;
 SetLength(MatSphere,6);
 L_Size:=9;

 //if not ReadIni then
 begin
  Winner:=0;
  DeleteSpeed:=30; //15
  F_Rad:=0.45;
  MinLevel:=-0.2;
  MaxLevel:=0.0;
  MaxScale:=0.15;
  JumpSpeed:=300;    //180
  MoveSpeed:=20;    //15
  SaveAll:=1;
  DisMoveDelay:=200;
  Smooth:=14;
  SaveIni;
 end;

 MatSphere[0].ambient[0]:=0.5;  MatSphere[0].ambient[1]:=1.0;  MatSphere[0].ambient[2]:=1.0;  MatSphere[0].ambient[3]:=1.0;
 MatSphere[0].diffuse[0]:=0.3;  MatSphere[0].diffuse[1]:=0.5;  MatSphere[0].diffuse[2]:=0.5;  MatSphere[0].diffuse[3]:=1.0;
 MatSphere[0].specular[0]:=0.9; MatSphere[0].specular[1]:=0.5; MatSphere[0].specular[2]:=0.9; MatSphere[0].specular[3]:=1.0;
 MatSphere[0].emission[0]:=0.0; MatSphere[0].emission[1]:=0.0; MatSphere[0].emission[2]:=0.0; MatSphere[0].emission[3]:=1.0;
 MatSphere[0].shininess:=100;
 MatSphere[0].lmodel_ambient[0]:=0.3;   MatSphere[0].lmodel_ambient[1]:=0.3; MatSphere[0].lmodel_ambient[2]:=0.3; MatSphere[0].lmodel_ambient[3]:=1.0;


 MatSphere[1].ambient[0]:=0.7;  MatSphere[1].ambient[1]:=0.4;  MatSphere[1].ambient[2]:=1.0;  MatSphere[1].ambient[3]:=1.0;
 MatSphere[1].diffuse[0]:=0.4;  MatSphere[1].diffuse[1]:=0.2;  MatSphere[1].diffuse[2]:=0.7;  MatSphere[1].diffuse[3]:=1.0;
 MatSphere[1].specular[0]:=0.3; MatSphere[1].specular[1]:=1.0; MatSphere[1].specular[2]:=1.0; MatSphere[1].specular[3]:=1.0;
 MatSphere[1].emission[0]:=0.0; MatSphere[1].emission[1]:=0.0; MatSphere[1].emission[2]:=0.0; MatSphere[1].emission[3]:=1.0;
 MatSphere[1].shininess:=100;
 MatSphere[1].lmodel_ambient[0]:=0.4;   MatSphere[1].lmodel_ambient[1]:=0.9; MatSphere[1].lmodel_ambient[2]:=0.4; MatSphere[1].lmodel_ambient[3]:=1.0;


 MatSphere[2].ambient[0]:=0.8;  MatSphere[2].ambient[1]:=0.3;  MatSphere[2].ambient[2]:=0.5;  MatSphere[2].ambient[3]:=1.0;
 MatSphere[2].diffuse[0]:=0.5;  MatSphere[2].diffuse[1]:=0.2;  MatSphere[2].diffuse[2]:=0.5;  MatSphere[2].diffuse[3]:=1.0;
 MatSphere[2].specular[0]:=0.5; MatSphere[2].specular[1]:=1.0; MatSphere[2].specular[2]:=1.0; MatSphere[2].specular[3]:=1.0;
 MatSphere[2].emission[0]:=0.0; MatSphere[2].emission[1]:=0.0; MatSphere[2].emission[2]:=0.0; MatSphere[2].emission[3]:=1.0;
 MatSphere[2].shininess:=100;
 MatSphere[2].lmodel_ambient[0]:=0.3;   MatSphere[2].lmodel_ambient[1]:=0.3; MatSphere[2].lmodel_ambient[2]:=0.4; MatSphere[2].lmodel_ambient[3]:=1.0;


 MatSphere[3].ambient[0]:=1.0;  MatSphere[3].ambient[1]:=0.5;  MatSphere[3].ambient[2]:=0.4;  MatSphere[3].ambient[3]:=1.0;
 MatSphere[3].diffuse[0]:=1.0;  MatSphere[3].diffuse[1]:=0.5;  MatSphere[3].diffuse[2]:=0.4;  MatSphere[3].diffuse[3]:=1.0;
 MatSphere[3].specular[0]:=0.5; MatSphere[3].specular[1]:=1.0; MatSphere[3].specular[2]:=5.0; MatSphere[3].specular[3]:=1.0;
 MatSphere[3].emission[0]:=0.0; MatSphere[3].emission[1]:=0.0; MatSphere[3].emission[2]:=0.0; MatSphere[3].emission[3]:=1.0;
 MatSphere[3].shininess:=100;
 MatSphere[3].lmodel_ambient[0]:=0.5;   MatSphere[3].lmodel_ambient[1]:=0.3; MatSphere[3].lmodel_ambient[2]:=0.2; MatSphere[3].lmodel_ambient[3]:=1.0;


 MatSphere[4].ambient[0]:=0.5;  MatSphere[4].ambient[1]:=1.0;  MatSphere[4].ambient[2]:=0.5;  MatSphere[4].ambient[3]:=1.0;
 MatSphere[4].diffuse[0]:=0.3;  MatSphere[4].diffuse[1]:=0.9;  MatSphere[4].diffuse[2]:=0.5;  MatSphere[4].diffuse[3]:=1.0;
 MatSphere[4].specular[0]:=5.0; MatSphere[4].specular[1]:=0.3; MatSphere[4].specular[2]:=1.0; MatSphere[4].specular[3]:=1.0;
 MatSphere[4].emission[0]:=0.0; MatSphere[4].emission[1]:=0.0; MatSphere[4].emission[2]:=0.1; MatSphere[4].emission[3]:=1.0;
 MatSphere[4].shininess:=100;
 MatSphere[4].lmodel_ambient[0]:=0.2;   MatSphere[4].lmodel_ambient[1]:=0.4; MatSphere[4].lmodel_ambient[2]:=0.4; MatSphere[4].lmodel_ambient[3]:=1.0;


 MatSphere[5].ambient[0]:=0.9;  MatSphere[5].ambient[1]:=0.7;  MatSphere[5].ambient[2]:=0.1;  MatSphere[5].ambient[3]:=1.0;
 MatSphere[5].diffuse[0]:=0.8;  MatSphere[5].diffuse[1]:=0.6;  MatSphere[5].diffuse[2]:=0.1;  MatSphere[5].diffuse[3]:=1.0;
 MatSphere[5].specular[0]:=3.0; MatSphere[5].specular[1]:=1.0; MatSphere[5].specular[2]:=1.0; MatSphere[5].specular[3]:=1.0;
 MatSphere[5].emission[0]:=0.0; MatSphere[5].emission[1]:=0.0; MatSphere[5].emission[2]:=0.0; MatSphere[5].emission[3]:=1.0;
 MatSphere[5].shininess:=100;
 MatSphere[5].lmodel_ambient[0]:=0.3;   MatSphere[5].lmodel_ambient[1]:=0.3; MatSphere[5].lmodel_ambient[2]:=0.5; MatSphere[5].lmodel_ambient[3]:=1.0;



 F_BackShift:=20;
 B_Jump:=False;
 Application.OnIdle:=Idle;
 NewGame;
 ShowField;

{
SetLength(BuffS,15);
BuffS[0]:=0;
BuffS[1]:=4;
BuffS[2]:=4;
BuffS[3]:=2;
BuffS[4]:=1;
BuffS[5]:=1;
BuffS[6]:=5;
BuffS[7]:=5;
BuffS[8]:=4;
BuffS[9]:=8;
BuffS[10]:=4;
BuffS[11]:=4;
BuffS[12]:=2;
BuffS[13]:=5;
BuffS[14]:=3;
F_Pos:=1;
SetLength(BuffField,9);
SetLength(DUS,200);
BuffField[0]:=4;
Pack;
Unpack(0);
For i:=0 to F_Test do
M1.Lines[i]:=IntToStr(DUS[i]);
}




end;


procedure TfrmGL.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0, 0);
 wglDeleteContext(hrc);
 ReleaseDC (hnd, DC);
 DeleteDC (DC);
end;

procedure TfrmGL.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 //If Key = VK_ESCAPE then Close;
 //Label1.Caption:=IntToStr(Key);
end;

procedure TfrmGL.FormResize(Sender: TObject);
begin
_Width:=PFLD.Width; _Height:=PFLD.Height;

 glViewport(0, 0, _Width, _Height);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 if _Width <= (_Height * 2)
    then glOrtho (-6.0, 6.0, -3.0*(_Height*2)/_Width,
         3.0*(_Height*2)/_Width, -10.0, 10.0)
    else
        glOrtho (-6.0*_Width/(_Height*2),
        6.0*_Width/(_Height*2), -3.0, 3.0, -10.0, 10.0);
    glMatrixMode(GL_MODELVIEW);
  SwapBuffers(DC);
end;



procedure TfrmGL.Tm1Timer(Sender: TObject);
var
i,j: Integer;
Cl: TColor;
Pixel: array [0..51,0..51,0..2]of GLUByte;
tx,ty: GLFloat;
begin
if F_UpDown = 2 then RY:=RY-dx
else
if F_UpDown = 1 then RY:=RY+dx;

if (RY <= -0.15) and (F_CompStrch = 0) then F_CompStrch:=1;
if (RY >= 0.07) then F_UpDown:=2;

if F_CompStrch = 1 then Sc:=Sc+ds
else
if F_CompStrch = 2 then Sc:=Sc-ds;


if (F_CompStrch = 1) and (Sc >= 0.1) then
begin
F_CompStrch:=2; F_UpDown:=1;
end;
if (F_CompStrch = 2) and (Sc < 0) then
begin
F_CompStrch:=0;

fds:=fds+0.2;
end;

SetMaterial(Field[XPos,YPos]);
DrawSphere(XPos,YPos);
end;



procedure TfrmGL.Tm2Timer(Sender: TObject);
begin
ds:=fds+0.05;
InvalidateRect(Handle, nil, False);
end;






procedure TFrmGl.DrawSphere(x,y: Integer);
var
    Nt: Integer;
     pos,pos1: array [0..3] of GLFloat;
    TX,TY: GLFloat;
begin


GetInnerCoord(Coord[x,y].x,Coord[x,y].y,tx,ty);
glEnable(GL_SCISSOR_TEST);
glScissor(CoordSC[x,y].x,CoordSc[x,y].y,52,52);
glClearColor(0.75,0.75,0.75,1);
glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

glPushMatrix;


pos[0]:=Lpos[0]+TX; pos[1]:=Lpos[1]+TY+RY; pos[2]:=Lpos[2]; pos[3]:=Lpos[3];
pos1[0]:=(TX+Lpos1[0]); pos1[1]:=TY+RY+Lpos1[1]; pos1[2]:=Lpos1[2]; pos1[3]:=Lpos1[3];



glLightfv(GL_LIGHT0, GL_POSITION, @pos);
glLightfv(GL_LIGHT1,GL_POSITION,@pos1);

glTranslatef (0+TX,RY+TY,-2);
glScalef(1+Sc,1-Sc,1.0);
glutSolidSphere(F_Rad, Smooth, Smooth);
glPopMatrix;


SwapBuffers(DC);
glDisable(GL_SCISSOR_TEST);

end;





procedure TfrmGL.PFLDMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
label 1;
var
 i,j,x1,y1,nc: Integer;
 WX,WY,AX,AY: TArray1;
 BH: Boolean;
begin

x1:=XPos; y1:=YPos;
for i:=0 to 8 do
for j:=0 to 8 do
begin
 if (x > CoordSc[i,j].x) and (x < CoordSC[i,j].x+ 52) and
    (y < (_Height-CoordSc[i,j].y)) and (y > (_Height-(CoordSC[i,j].y+ 52))) then
    begin
     XPos:=i; YPos:=j; goto 1;
    end;
end;

1:


if B_Jump then
begin
 if Field[XPos,YPos] <> 0 then
 begin
  B_Jump:=False;
  RY:=0; SC:=0;
  DrawSphere(x1,y1);
  B_Jump:=True;
 end
 else
 begin
  CanMove(x1,y1,XPos,YPos,WX,WY,BH);
  if BH then
  begin
   B_Jump:=False;
   Field[XPos,YPos]:=Field[x1,y1]; Field[x1,y1]:=0;
   MoveSphere(x1,y1,XPos,YPos);
   FindRemove(XPos,YPos,AX,AY);
   if Length(AX) > 0 then
   begin
   RemoveSphere(AX,AY);
   DeleteSphere(AX,AY);
   AddBuff(x1,y1,0);
   AddPoints(Length(AX));
   CopyField;
   end
   else
   if not CheckEndGame then
   begin
    AddBuff(XPos,YPos,Field[XPos,YPos]);
    AddBuff(x1,y1,0);
    F_Pt:=0;
    for i:=0 to 2 do
    begin
     B_Jump:=False;
     SC:=0; RY:=0;
     RandomSphere(x,y,nc);
     Field[x,y]:=Preview[i];
     SetMaterial(Field[x,y]);
     DrawSphere(x,y);
     FindRemove(x,y,AX,AY);
     if Length(AX) <> 0 then
     begin
      RemoveSphere(AX,AY);
      DeleteSphere(AX,AY);
     end
     else
      AddBuff(x,y,Preview[i]);
    end;
    RandomPreview;
    CopyField;
    ShowPreview;
   end
   else
   begin
    NewGame;
   end;
  end
  else
  begin
   ShowDisableMove(XPos,YPos);
   XPos:=x1; YPos:=y1;
  end;
 end;
end
else
begin
 if Field[XPos,YPos] <> 0 then
 begin
 B_Jump:=True;
 end;
end;


end;



procedure TFrmGl.AddPoints(N: Integer);
begin
F_Points:=F_Points+N*2+(N-5)*6;
F_Pt:=N*2+(N-5)*6;
PP.Caption:=IntToStr(F_Points);
end;



function TFrmGl.CheckEndGame: Boolean;
var
i,j,N: Integer;
begin
N:=0;
for i:=0 to 8 do
for j:=0 to 8 do
begin
 if Field[i,j] = 0 then inc(N);
end;
if N <= 3 then CheckEndGame:=True else CheckEndGame:=False;
end;



procedure TFrmGl.DeleteSphere(AX,AY: TArray1);
var
i,k: Integer;
begin

 for i:=0 to High(AX) do
 begin
  if (AX[i] = XPos) and (AY[i] = YPos) then k:=i;
 end;

 for i:=0 to High(AX) do
 begin
  Field[AX[i],AY[i]]:=0;
  //AddBuff(AX[i],AY[i],0);
  if i <> k then AddBuff(AX[i],AY[i],0);
 end;


{
for i:=0 to High(BuffS) do
begin
 M2.Lines[i]:=IntToStr(BuffS[i]);
end;
}
end;



procedure TFrmGl.ShowPreview;
var
i: Integer;
begin
wglMakeCurrent(0,0);
wglMakeCurrent(DC1, hrc1);

glViewport(0, 0, Pv.Width, Pv.Height);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 if Pv.Width <= (Pv.Height * 2)
    then glOrtho (-6.0, 6.0, -3.0*(Pv.Height*2)/Pv.Width,
         3.0*(Pv.Height*2)/Pv.Width, -10.0, 10.0)
    else
        glOrtho (-6.0*Pv.Width/(Pv.Height*2),
        6.0*Pv.Width/(Pv.Height*2), -3.0, 3.0, -10.0, 10.0);
    glMatrixMode(GL_MODELVIEW);

 glEnable(GL_DEPTH_TEST);
 glEnable(GL_LIGHTING);
 glEnable(GL_LIGHT0);
 glEnable(GL_LIGHT1);

 glClearColor(0.75,0.75,0.75,1);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);


 glLightfv(GL_LIGHT1, GL_AMBIENT,  @L1_Ambient);
 glLightfv(GL_LIGHT1, GL_DIFFUSE,  @L1_Diffuse);
 glLightfv(GL_LIGHT1, GL_SPECULAR, @L1_Specular);


 glLightfv(GL_LIGHT0, GL_AMBIENT,  @L0_Ambient);
 glLightfv(GL_LIGHT0, GL_DIFFUSE,  @L0_Diffuse);
 glLightfv(GL_LIGHT0, GL_SPECULAR, @L0_Specular);



for i:=0 to 2 do
begin
SetMaterial(Preview[i]);
DrawSpherePv(i*7-7,0);
end;

SwapBuffers(DC1);
wglMakeCurrent(0,0);
wglMakeCurrent(DC, hrc);
FrmGl.FormResize(FrmGl);
end;



procedure TFrmGl.ShowDisableMove(x,y: Integer);
var
x1,x2,x3,x4,y1,y2,y3,y4: GLFloat;
xs,ys,i,j,k: Integer;
begin
glEnable(GL_SCISSOR_TEST);
glScissor(CoordSC[x,y].x,CoordSc[x,y].y,52,52);
glClearColor(1,0,0,1);
glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

SwapBuffers(DC);
glDisable(GL_SCISSOR_TEST);

for i:=0 to DisMoveDelay do
for j:=0 to DisMoveDelay do
for k:=0 to DisMoveDelay do
begin  end;

ClearSquare(x,y);
end;




procedure TFrmGl.DrawSpherePv(x,y: Integer);
var
    Nt: Integer;
     pos,pos1: array [0..3] of GLFloat;
    TX,TY: GLFloat;
begin
tx:=x; ty:=y;
glPushMatrix;

pos[0]:=Lpos[0]+TX; pos[1]:=Lpos[1]+TY; pos[2]:=Lpos[2]; pos[3]:=1;//Lpos[3];
pos1[0]:=(TX+Lpos1[0]); pos1[1]:=TY+Lpos1[1]; pos1[2]:=Lpos1[2]; pos1[3]:=1;//Lpos1[3];


glLightfv(GL_LIGHT0, GL_POSITION, @pos);
glLightfv(GL_LIGHT1,GL_POSITION,@pos1);


glTranslatef (Tx,Ty,-2);
glutSolidSphere(2.5,Smooth,Smooth);
glPopMatrix;
end;



procedure TFrmGl.ClearSquare(x,y: Integer);
begin
glEnable(GL_SCISSOR_TEST);
glScissor(CoordSC[x,y].x,CoordSc[x,y].y,52,52);
glClearColor(0.75,0.75,0.75,1);
glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

SwapBuffers(DC);
glDisable(GL_SCISSOR_TEST);
end;


procedure TFrmGl.NewGame;
var
i,j,x,y,nc: Integer;
begin
SC:=0; RY:=0; B_Jump:=False;
F_CurrentField:=1;
F_NumberFields:=1;
BuffS:=nil;
Randomize;
for i:=0 to 8 do
for j:=0 to 8 do
begin
 Field[i,j]:=0;
 BackField[i,j]:=0;
end;

for i:=1 to 3 do
begin
RandomSphere(x,y,nc);
Field[x,y]:=nc;
end;

RandomPreview;

if F_Points > Winner then
begin
 Winner:=F_Points;
 SaveIni;
end;
F_Points:=0;
InitField;

ShowField;
ShowPreview;
Right.Enabled:=False;
Back.Enabled:=False;
PP.Caption:=IntToStr(F_Points);
PW.Caption:=IntToStr(Winner);


//
{for i:=0 to High(BuffField) do
begin
 M1.Lines[i]:=IntToStr(BuffField[i])+'('+IntToStr(i)+')';
end;

Label1.Caption:=IntToStr(F_RightPos);
Label2.Caption:=IntToStr(F_BackPos);}
end;




procedure TFrmGl.InitField;
var
i,j,k: Integer;
P: Pointer;
begin                    //-------pack--------//
 //ID,size,nc,nth,[N(1b),(x,y,c)*N(3Nb),PrC(3b),Point(1b)],[......],...
 SetLength(BuffField,23);
 //'lines_sl':
 BuffField[0]:=76; BuffField[1]:=73; BuffField[2]:=78; BuffField[3]:=69;
 BuffField[4]:=83; BuffField[5]:=189; BuffField[6]:=83; BuffField[7]:=76;
 //size(9),number_color(6),number_random(3)
 BuffField[8]:=9; BuffField[9]:=6; BuffField[10]:=3;
 //11,12,13,14 - NFields (  )
 //N
 BuffField[15]:=3;


 SetLength(BuffS,12);
 k:=-1;
 for i:=0 to 8 do
 for j:=0 to 8 do
 begin
  if Field[i,j] <> 0 then
  begin
   inc(k); BuffS[k]:=i;
   inc(k); BuffS[k]:=j;
   inc(k); BuffS[k]:=Field[i,j];
  end;
 end;

 BuffS[k+1]:=Preview[0];  BuffS[k+2]:=Preview[1]; BuffS[k+3]:=Preview[2];

 F_Pos:=16;
 Pack;
 BuffField[22]:=0;
 F_Pos:=23;
 F_BPos:=15; // 

 SetLength(DUS,200); //help for unpack; 200 ~ max need length

 F_BackNum:=0;       // |<<|
 F_BackPos:=F_BPos;  // |<<|
 F_BackPoint:=0;     //for |<<|

 //F_BackPos:=28;
 //F_RightPos:=11;
end;




procedure TfrmGl.Pack;
var
b1,b2,m: byte;
l,j,k,N: Integer;
begin
 k:=Length(BuffS);
 l:=0;
 N:=F_Pos;

for j:=0 to k div 2 - 1 do
begin

 b1:=BuffS[l]; b2:=BuffS[l+1]; l:=l+2;
 asm
  push  ax
  push  bx
  xor   ax,ax
  xor   bx,bx

  mov   bl,b2
  mov   al,b1
  shl   bx,12
  shrd  bx,ax,12
  mov   m,bl
  pop   bx
  pop   ax
 end;

 BuffField[N+j]:=m;
end;

if k/2 <> Trunc(k/2) then BuffField[N+k div 2]:=BuffS[l];

{for j:=0 to High(BuffS) do
begin
 M1.Lines[j]:=IntToStr(BuffS[j])+'('+IntToStr(j)+')';
end; }

BuffS:=nil;
end;







procedure TfrmGl.Unpack(N: Integer);
var
b1,b2,m,f: byte;
l,j,k,N3,d: Integer;
begin
 f:=0;
 l:=-1;
 k:=BuffField[N]*3+3;
 N3:=BuffField[N]*3;
 inc(N);
 d:=k div 2;

for j:=0 to d - 1 do
begin

 m:=BuffField[N+j];
 asm
  push  ax
  push   bx
  xor   ax,ax
  xor   bx,bx

  mov   al,m
  shrd  bx,ax,4
  shr   ax,4
  shr   bx,12
  mov   b1,al
  mov   b2,bl

  pop   bx
  pop   ax
 end;

 inc(l); DUS[l]:=b1;
 inc(l); DUS[l]:=b2;
end;

asm
  push eax
  mov  eax,k
  shr  eax,1
  jae  @1
  mov  eax,l
  inc  eax
  mov  l,eax
  mov  f,1
  @1:
  pop  eax
end;

//if k/2 <> Trunc(k/2) then begin inc(l); DUS[l]:=BuffField[N+d+1]; end;
if f = 1 then DUS[l]:=BuffField[N+d];

F_Test:=l;
{for j:=0 to l do
begin
 M2.Lines[j]:=IntToStr(DUS[j])+'('+IntToStr(j)+')';
end; }
end;



procedure TFrmGl.RandomPreview;
var
i,nc: Integer;
begin
//Randomize;
for i:=0 to 2 do
begin
 nc:=Trunc(Random*6+1);
 Preview[i]:=nc;
end;
end;


procedure TFrmGl.RandomSphere(var x,y,nc: Integer);
label 1;
begin
//Randomize;
1:
x:=Trunc(Random*9);
y:=Trunc(Random*9);
if Field[x,y] <> 0 then goto 1;

nc:=Trunc(Random*6+1);
end;



procedure TFrmGl.AddBuff(x,y,nc: Byte);
var
k: Integer;
begin
SetLength(BuffS,Length(BuffS)+3);
k:=High(BuffS);
BuffS[k-2]:=x; BuffS[k-1]:=y; BuffS[k]:=nc;
end;



procedure TFrmGl.CopyField;
var
i,j,k,L,N: Integer;
P: ^Integer;
Pt: Byte;
//DS: TArrayB;
begin

{
SetLength(DS,1+Length(BuffS));
for i:=0 to High(BuffS) do
begin
 DS[i+1]:=BuffS[i]
end;


N:=Length(BuffS);
DS[0]:=N;
SetLength(DS,Length(DS)+3);
k:=High(DS);
DS[k-2]:=Preview[0];  DS[k-1]:=Preview[1]; DS[k]:=Preview[2];
SetLength(DS,Length(DS)+4);
P:=@DS[High(DS)-3];
P^:=F_Points;



SetLength(DS,Length(DS)+1);
DS[High(DS)]:=N;

L:=F_BackPos;
SetLength(BuffField,L+Length(DS)+1);
for i:=0 to High(DS) do
begin
 BuffField[F_BackPos+i+1]:=DS[i];
end;
}



k:=High(BuffS);
SetLength(BuffS,Length(BuffS)+3);
BuffS[k+1]:=Preview[0];
BuffS[k+2]:=Preview[1];
BuffS[k+3]:=Preview[2];

L:=Length(BuffS);

if L/2 <> Trunc(L/2) then k:=L div 2 + 1 else k:=L div 2;
SetLength(BuffField,F_Pos+k+2);

BuffField[F_Pos]:=(L-3) div 3;
inc(F_Pos);
Pack;
F_Pos:=F_Pos+k;
BuffField[F_Pos]:=F_Pt;
inc(F_Pos);

//F_BackPos:=High(BuffField);
//F_RightPos:=F_BackPos-(8+N);
inc(F_CurrentField);
//BuffS:=nil;
F_NumberFields:=F_CurrentField;



//



Right.Enabled:=False;
Back.Enabled:=True;



end;


procedure TFrmGl.ShowField;
var
i,j,nc: Integer;
begin
B_Jump:=False;
 CreateField;
 for i:=0 to 8 do
 for j:=0 to 8 do
 begin
  nc:=Field[i,j];
  if nc <> 0 then
  begin
   SetMaterial(Field[i,j]);
   DrawSphere(i,j);
  end; 
 end;
end;



procedure TFrmGl.GetPossibleMoves(x,y: Integer; var AX,AY: TArray1; var BH: Boolean);
var
N1,N2,N3,N4,N: Integer;
begin
BH:=False;
N:=0;
N1:=0; N2:=0; N3:=0; N4:=0;

//(-1,0)
if ((x-1) >= 0) and (Field_C[x-1,y] = 0) and (Way[x-1,y] = 0) then
begin
 N1:=1;
end;
//(+1,0)
if ((x+1) < L_Size) and (Field_C[x+1,y] = 0) and (Way[x+1,y] = 0) then
begin
 N2:=1;
end;
//(0,-1)
if ((y-1) >= 0) and (Field_C[x,y-1] = 0) and (Way[x,y-1] = 0) then
begin
 N3:=1;
end;
//(0,+1)
if ((y+1) < L_Size) and (Field_C[x,y+1] = 0) and (Way[x,y+1] = 0) then
begin
 N4:=1;
end;


N:=N1+N2+N3+N4;
if N <> 0 then
begin
 BH:=True;
 SetLength(AX,N);  SetLength(AY,N);
 N:=0;
 if N1 = 1 then begin AX[N]:=x-1; AY[N]:=y; inc(N); end;
 if N2 = 1 then begin AX[N]:=x+1; AY[N]:=y; inc(N); end;
 if N3 = 1 then begin AX[N]:=x;   AY[N]:=y-1; inc(N); end;
 if N4 = 1 then begin AX[N]:=x;   AY[N]:=y+1; inc(N); end;
end;


end;



procedure TFrmGl.GetNearestMove(xn,yn: Integer; AX,AY: TArray1; var x,y: Integer);
var
i,j: Integer;
d,d1: Integer;
begin
d:=abs(xn-AX[0])+abs(yn-AY[0]); j:=0;
 for i:=1 to High(AX) do
 begin
   d1:=abs(xn-AX[i])+abs(yn-AY[i]);
   if d1 < d then begin d:=d1; j:=i; end;
 end;

x:=AX[j]; y:=AY[j];
end;




procedure TFrmGl.CanMove(x1,y1,xn,yn: Integer; var WX,WY: TArray1; var BH: Boolean);
label beginp,1,endp;
var
x,y,N,i,j,L: Integer;
BH1: Boolean;
AX,AY: TArray1;
begin
//SetLength(Field_C,L_Size,L_Size);
for i:=0 to L_Size-1 do
  for j:=0 to L_Size-1 do
   Field_C[i,j]:=Field[i,j];

beginp:
x:=x1; y:=y1; SetLength(WX,1); SetLength(WY,1); WX[0]:=x1; WY[0]:=y1; N:=1;
//SetLength(Way,L_Size,L_Size);
for i:=0 to L_Size-1 do
  for j:=0 to L_Size-1 do
   Way[i,j]:=0;{Way[i,j]:=-1;}

1:
GetPossibleMoves(x,y,AX,AY,BH1);
if BH1 = False then
begin
 Field_C[x,y]:=1;
 N:=N-1;
 if N = 0 then
 begin
  BH:=False; goto endp;
 end;
 goto beginp;
end
 else
begin
 GetNearestMove(xn,yn,AX,AY,x,y);
 N:=N+1;
 {SetLength(WX,N); SetLength(WY,N);
 WX[N-1]:=x;      WY[N-1]:=y;}
 Way[x,y]:=1;

 if (x = xn) and (y = yn) then
 begin
  BH:=True;
  goto endp;
 end;

 goto 1;

end;

endp:
end;




procedure TFrmGl.FindNearestSame(x,y,dx,dy: Integer; var N: Integer);
label endp;
var
c,x1,y1: Integer;
begin
c:=Field[x,y]; N:=0;
x1:=x; y1:=y;
x1:=x1+dx; y1:=y1+dy;
while (x1 >= 0) and (x1 <= L_Size-1) and (y1 >= 0) and (y1 <= L_Size-1) do
begin
  if Field[x1,y1] = c then inc(N) else  goto endp;
  x1:=x1+dx; y1:=y1+dy;
end;

endp:
end;




procedure TFrmGl.FindRemove(x,y: Integer; var AX,AY: TArray1);
var
N,N1,N2,i,S,xn,yn: Integer;
begin
AX:=nil; AY:=nil;
 N:=0;
 FindNearestSame(x,y,0,1,N1);
 FindNearestSame(x,y,0,-1,N2);
 S:=0;
 if N1+N2 >= Min_Out-1 then
 begin
  N:=N1+N2;
  SetLength(AX,Length(AX)+N);
  SetLength(AY,Length(AY)+N);
  xn:=x; yn:=y;
  for i:=1 to N1 do
  begin
   yn:=yn+1;
   AX[S]:=x; AY[S]:=yn;inc(S);
  end;
  xn:=x; yn:=y;
  for i:=1 to N2 do
  begin
   yn:=yn-1;
   AX[S]:=x; AY[S]:=yn; inc(S);
  end;

 end;



 FindNearestSame(x,y,1,0,N1);
 FindNearestSame(x,y,-1,0,N2);
 if N1+N2 >= Min_Out-1 then
 begin
  N:=N1+N2;
  SetLength(AX,Length(AX)+N);
  SetLength(AY,Length(AY)+N);
  xn:=x; yn:=y;
  for i:=1 to N1 do
  begin
   xn:=xn+1;
   AX[S]:=xn; AY[S]:=yn;inc(S);
  end;
  xn:=x; yn:=y;
  for i:=1 to N2 do
  begin
   xn:=xn-1;
   AX[S]:=xn; AY[S]:=yn; inc(S);
  end;

 end;




 
 FindNearestSame(x,y,1,1,N1);
 FindNearestSame(x,y,-1,-1,N2);
 if N1+N2 >= Min_Out-1 then
 begin
  N:=N1+N2;
  SetLength(AX,Length(AX)+N);
  SetLength(AY,Length(AY)+N);
  xn:=x; yn:=y;
  for i:=1 to N1 do
  begin
   xn:=xn+1;yn:=yn+1;
   AX[S]:=xn; AY[S]:=yn;inc(S);
  end;
  xn:=x; yn:=y;
  for i:=1 to N2 do
  begin
   xn:=xn-1;  yn:=yn-1;
   AX[S]:=xn; AY[S]:=yn; inc(S);
  end;

 end;




 
 
 FindNearestSame(x,y,1,-1,N1);
 FindNearestSame(x,y,-1,1,N2);
 if N1+N2 >= Min_Out-1 then
 begin
  N:=N1+N2;
  SetLength(AX,Length(AX)+N);
  SetLength(AY,Length(AY)+N);
  xn:=x; yn:=y;
  for i:=1 to N1 do
  begin
   xn:=xn+1;yn:=yn-1;
   AX[S]:=xn; AY[S]:=yn;inc(S);
  end;
  xn:=x; yn:=y;
  for i:=1 to N2 do
  begin
   xn:=xn-1;  yn:=yn+1;
   AX[S]:=xn; AY[S]:=yn; inc(S);
  end;

 end;


 if Length(AX) > 0 then
 begin
 SetLength(AX,Length(AX)+1);
 SetLength(AY,Length(AY)+1);
 AX[High(AX)]:=x;
 AY[High(AY)]:=y;
 end;
end;




procedure  TFrmGl.RemoveSphere(AX,AY: TArray1);
var
i,j,x,y,nc,n: Integer;
fogCl: array [0..3] of GLFloat;
tx,ty,df: GLFloat;
Pixel: array [0..52,0..52,0..2]of GLUByte;
 pos,pos1: array [0..3] of GLFloat;
begin
 x:=AX[0]; y:=AY[0];
 nc:=Field[x,y]; n:=Length(AX)-1;
 fogCl[0]:=0.75;  fogCl[1]:=0.75; fogCl[2]:=0.75; fogCl[3]:=1;
 SetMaterial(nc);
 glEnable(GL_FOG);
 glFogfv(GL_FOG_COLOR,@fogCl);
 glFogi(GL_FOG_MODE,GL_EXP2);
 glHint(GL_FOG_HINT, GL_NICEST);
 glEnable(GL_SCISSOR_TEST);

 fds:=0;
 df:=1.5/DeleteSpeed;
 for i:=1 to DeleteSpeed do
 begin
  glFogf(GL_FOG_DENSITY,fds);
  for j:=0 to n do
  begin
   x:=AX[j]; y:=AY[j];
   GetInnerCoord(Coord[x,y].x,Coord[x,y].y,tx,ty);
   glScissor(CoordSC[x,y].x,CoordSc[x,y].y,52,52);
   glClearColor(0.75,0.75,0.75,1);
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
   glPushMatrix;

   pos[0]:=Lpos[0]+TX; pos[1]:=Lpos[1]+TY; pos[2]:=Lpos[2]; pos[3]:=Lpos[3];
   pos1[0]:=(TX+Lpos1[0]); pos1[1]:=TY+Lpos1[1]; pos1[2]:=Lpos1[2]; pos1[3]:=Lpos1[3];

   glLightfv(GL_LIGHT0, GL_POSITION, @pos);
   glLightfv(GL_LIGHT1,GL_POSITION,@pos1);

   glTranslatef (TX,TY,-2);
   glutSolidSphere(F_Rad, Smooth, Smooth);
   glPopMatrix;
  end;
  SwapBuffers(DC);
  fds:=fds+df;
 end;



glDisable(GL_SCISSOR_TEST);
glDisable(GL_FOG);
end;






procedure  TFrmGl.MoveSphere(x1,y1,x2,y2: Integer);
var
i,j,nc,n: Integer;
fogCl: array [0..3] of GLFloat;
tx,ty,df: GLFloat;
 pos,pos1: array [0..3] of GLFloat;
begin
 nc:=Field[x1,y1];
 fogCl[0]:=0.75;  fogCl[1]:=0.75; fogCl[2]:=0.75; fogCl[3]:=1;
 SetMaterial(nc);
 glEnable(GL_FOG);
 glFogfv(GL_FOG_COLOR,@fogCl);
 glFogi(GL_FOG_MODE,GL_EXP2);
 glHint(GL_FOG_HINT, GL_NICEST);
 glEnable(GL_SCISSOR_TEST);

 fds:=0; df:=1.5/MoveSpeed;
 for i:=1 to MoveSpeed do
 begin


   glFogf(GL_FOG_DENSITY,fds);

   GetInnerCoord(Coord[x1,y1].x,Coord[x1,y1].y,tx,ty);
   glScissor(CoordSC[x1,y1].x,CoordSc[x1,y1].y,52,52);
   glClearColor(0.75,0.75,0.75,1);
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
   glPushMatrix;

   pos[0]:=Lpos[0]+TX; pos[1]:=Lpos[1]+TY; pos[2]:=Lpos[2]; pos[3]:=Lpos[3];
   pos1[0]:=(TX+Lpos1[0]); pos1[1]:=TY+Lpos1[1]; pos1[2]:=Lpos1[2]; pos1[3]:=Lpos1[3];

   glLightfv(GL_LIGHT0, GL_POSITION, @pos);
   glLightfv(GL_LIGHT1,GL_POSITION,@pos1);

   glTranslatef (TX,TY,-2);
   glutSolidSphere(F_Rad, Smooth, Smooth);
   glPopMatrix;



   glFogf(GL_FOG_DENSITY,1.5-fds);

   GetInnerCoord(Coord[x2,y2].x,Coord[x2,y2].y,tx,ty);
   glScissor(CoordSC[x2,y2].x,CoordSc[x2,y2].y,52,52);
   glClearColor(0.75,0.75,0.75,1);
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
   glPushMatrix;

   pos[0]:=Lpos[0]+TX; pos[1]:=Lpos[1]+TY; pos[2]:=Lpos[2]; pos[3]:=Lpos[3];
   pos1[0]:=(TX+Lpos1[0]); pos1[1]:=TY+Lpos1[1]; pos1[2]:=Lpos1[2]; pos1[3]:=Lpos1[3];

   glLightfv(GL_LIGHT0, GL_POSITION, @pos);
   glLightfv(GL_LIGHT1,GL_POSITION,@pos1);

   glTranslatef (TX,TY,-2);
   glutSolidSphere(F_Rad, Smooth, Smooth);
   glPopMatrix;


  SwapBuffers(DC);
  fds:=fds+df;
 end;



glDisable(GL_SCISSOR_TEST);
glDisable(GL_FOG);
end;









procedure TFrmGl.SetLightPos;
begin
   Lpos[0]:=2; Lpos[1]:=5; Lpos[2]:=2; Lpos[3]:=1;
   Lpos1[0]:=-2; Lpos1[1]:=-3; Lpos1[2]:=2; Lpos1[3]:=2;
end;


procedure TFrmGl.SetMaterial(nc: Integer);
begin
 if nc <> 0 then
 begin
 nc:=nc-1;
 glMaterialfv(GL_FRONT, GL_AMBIENT, @MatSphere[nc].Ambient);
 glMaterialfv(GL_FRONT, GL_DIFFUSE, @MatSphere[nc].Diffuse);
 glMaterialfv(GL_FRONT, GL_SPECULAR,@MatSphere[nc].Specular);
 glMaterialfv(GL_FRONT, GL_SHININESS,@MatSphere[nc].Shininess);
 glMaterialfv(GL_FRONT, GL_EMISSION, @MatSphere[nc].Emission);
 glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @MatSphere[nc].lmodel_ambient);
 end;
end;


procedure TfrmGL.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if F_Points > Winner then
begin
 Winner:=F_Points;
 SaveIni;
end;
end;



procedure TFrmGl.Idle(Sender: TObject; var Done: Boolean);
label 1;
var
i,j,k: Integer;
Cl: TColor;
Pixel: array [0..51,0..51,0..2]of GLUByte;
tx,ty: GLFloat;
begin


1:
if B_Jump then
begin
 for i:=0 to JumpSpeed do
 for j:=0 to JumpSpeed do
 for k:=0 to JumpSpeed do
 begin
 end;

if F_UpDown = 2 then RY:=RY-dx
else
if F_UpDown = 1 then RY:=RY+dx;

if (RY <= MinLevel) and (F_CompStrch = 0) then F_CompStrch:=1;
if (RY >= MaxLevel) then F_UpDown:=2;

if F_CompStrch = 1 then Sc:=Sc+ds
else
if F_CompStrch = 2 then Sc:=Sc-ds;


if (F_CompStrch = 1) and (Sc >= MaxScale) then
begin
F_CompStrch:=2; F_UpDown:=1;
end;
if (F_CompStrch = 2) and (Sc < 0) then
begin
F_CompStrch:=0;

end;

//if Field[Xpos,Ypos] <> - 1 then
//begin
SetMaterial(Field[XPos,YPos]);
DrawSphere(XPos,YPos);
//end;
Done:=False;

end;
//if B_Jump then goto 1;

end;


procedure TfrmGL.BackClick(Sender: TObject);
var
i,j,k,N,NC,Pt,l,m,p: Integer;
begin
B_Jump:=False; SC:=0; RY:=0;
dec(F_CurrentField);

//old:
{
for i:=0 to 8 do
for j:=0 to 8 do
Field[i,j]:=0;
}

//new:
for i:=0 to 8 do
for j:=0 to 8 do
Field[i,j]:=BackField[i,j];

//old:
{Pt:=0;
N:=F_BPos;
k:=0;
}

//new
if (F_CurrentField >= 1) and (F_BackNum+1 > F_CurrentField) then GetBackPos(F_CurrentField-1);
N:=F_BackPos;
k:=F_BackNum;
Pt:=F_BackPoint;


while k < F_CurrentField do
begin
 Unpack(N);
 l:=0;
 while l < BuffField[N]*3 do
 begin
  Field[DUS[l],DUS[l+1]]:=DUS[l+2];
  l:=l+3;
 end;



 m:=BuffField[N]*3+3;  p:=m;
 asm
  push eax
  mov  eax,m
  shr  eax,1
  jae  @1
  lea  eax,eax+1
  @1:
  mov  m,eax
  pop  eax
 end;

 N:=N+m+2;
 Pt:=Pt+BuffField[N-1];
 inc(k);

end;


Preview[0]:=DUS[p-3];
Preview[1]:=DUS[p-2];
Preview[2]:=DUS[p-1];
F_Points:=Pt;
F_Pos:=N;
 ShowField;
 ShowPreview;
 PP.Caption:=IntToStr(F_Points);

 if F_CurrentField = 1 then Back.Enabled:=False;
 Right.Enabled:=True;

end;




//new:
procedure TFrmGl.GetBackPos(Pos: Integer);
var
i,j,k,N,NC,Pt,l,m,p: Integer;
begin

Pt:=0;
N:=F_BPos;
k:=0;


for i:=0 to 8 do
for j:=0 to 8 do
BackField[i,j]:=0;

while k < Pos do
begin
 Unpack(N);
 l:=0;
 while l < BuffField[N]*3 do
 begin
  BackField[DUS[l],DUS[l+1]]:=DUS[l+2];
  l:=l+3;
 end;



 m:=BuffField[N]*3+3;  p:=m;
 asm
  push eax
  mov  eax,m
  shr  eax,1
  jae  @1
  lea  eax,eax+1
  @1:
  mov  m,eax
  pop  eax
 end;

 N:=N+m+2;
 Pt:=Pt+BuffField[N-1];
 inc(k);

end;

F_BackPoint:=Pt;
F_BackPos:=N;
dec(F_BackNum);

end;



procedure TfrmGL.RightClick(Sender: TObject);
var
i,j,k,p,Pt,N,l,m: Integer;
begin
B_Jump:=False; SC:=0; RY:=0;



Pt:=F_Points;
N:=F_Pos;
k:=0;

Unpack(N);
l:=0;
while l < BuffField[N]*3 do
begin
  Field[DUS[l],DUS[l+1]]:=DUS[l+2];
  l:=l+3;
end;



m:=BuffField[N]*3+3;  p:=m;
asm
  push eax
  mov  eax,m
  shr  eax,1
  jae  @1
  lea  eax,eax+1
  @1:
  mov  m,eax
  pop  eax
end;

N:=N+m+2;
Pt:=Pt+BuffField[N-1];


Preview[0]:=DUS[p-3];
Preview[1]:=DUS[p-2];
Preview[2]:=DUS[p-1];
F_Points:=Pt;
F_Pos:=N;

 ShowField;
 ShowPreview;
 PP.Caption:=IntToStr(F_Points);

 inc(F_CurrentField);
 if F_CurrentField = F_NumberFields then Right.Enabled:=False;
 Back.Enabled:=True;

end;


procedure TfrmGL.SBNewClick(Sender: TObject);
begin
NewGame;
end;




procedure TFrmGl.WriteField(Name: String);
var
Buff: TArrayB;
AB: TArray4B;
i,j,k,n: Integer;
PF: Pointer;
Adr,L: Cardinal;
x: Integer;
FileHandle,NL: Integer;
CF: TArrayP3;
P: ^Integer;
begin

(*
if SaveAll = 0 then
begin
NL:=F_NumberFields;
L:=1;
end
else
if SaveAll = 1 then
begin
NL:=0;
L:=F_NumberFields;
end;


SetLength(Buff,4+4+L*4+L*3); //ID+LengthField+AllPoints+AllPreview
//Buff[0]:=-100; Buff[1]:=-101; Buff[2]:=-102; Buff[3]:=-103;//-Id

//IntToByte(L,AB);
for j:=1 to 4 do
 begin
  Buff[j+3]:=AB[j];
 end;

n:=8;

for i:=NL to High(WField) do
begin
//IntToByte(WField[i].Points,AB);
 for j:=1 to 4 do
 begin
  Buff[n]:=AB[j];
  inc(n);
 end;
end;

for i:=NL to High(WField) do
begin
  for j:=0 to 2 do
  begin
   Buff[n]:=WField[i].Preview[j];
   inc(n);
  end;
end;


InitSField;
for i:=NL to High(WField) do
begin
//CompareField(i,CF);
SetLength(Buff,Length(CF)*3+1);
Buff[n]:=Length(CF); inc(n);
for j:=0 to Length(CF) do
begin
 Buff[n]:=CF[j].x; inc(n);
 Buff[n]:=CF[j].y; inc(n);
 Buff[n]:=CF[j].c; inc(n);
end;
  {for j:=0 to 8 do
  begin
   for k:=0 to 8 do
   begin
   Buff[n]:=WField[i].Field[j,k];
   inc(n);
  end;
 end;}
end;
*)



P:=@BuffField[11];
P^:=F_NumberFields;
FileHandle:=FileCreate(Name);
FileWrite(FileHandle, BuffField[0], Length(BuffField));
FileClose(FileHandle);


Buff:=nil;
end;





procedure TFrmGl.ReadField(Name: String);
label endp;
var
i,j,n,k,L,Pt,m: Integer;
f: file of Byte;
size: Cardinal;
Buff: TArrayB;
FileHandle,p: Integer;
Pm: ^Integer;
begin

AssignFile(f, Name);
Reset(f);
size := FileSize(f);
CloseFile(F);


SetLength(BuffField,size);
FileHandle := FileOpen(Name, fmOpenRead);
FileRead(FileHandle, BuffField[0], Length(BuffField));
FileClose(FileHandle);



if  (BuffField[0]<>76) or (BuffField[1]<>73) or (BuffField[2]<>78)  or
    (BuffField[3]<>69) or (BuffField[4]<>83) or (BuffField[5]<>189) or
    (BuffField[6]<>83) or (BuffField[7]<>76) then
begin
 MessageBeep(MB_ICONHAND);
 MessageDlg('No Lines file or file damaged',mtError,[mbOk],0);
 BuffField:=nil;
 goto endp;
end;



Pm:=@BuffField[11];
F_NumberFields:=Pm^;

for i:=0 to 8 do
for j:=0 to 8 do
begin
 Field[i,j]:=0;
 BackField[i,j]:=0;
end;

F_BackNum:=F_NumberFields-F_BackShift;
F_BackPos:=F_BPos;
Pt:=0;
N:=F_BPos;
k:=0;
while k < F_NumberFields do
begin
 Unpack(N);
 l:=0;
 while l < BuffField[N]*3 do
 begin
  Field[DUS[l],DUS[l+1]]:=DUS[l+2];
  l:=l+3;
 end;


 m:=BuffField[N]*3+3;  p:=m;
 asm
  push eax
  mov  eax,m
  shr  eax,1
  jae  @1
  lea  eax,eax+1
  @1:
  mov  m,eax
  pop  eax
 end;

 N:=N+m+2;
 Pt:=Pt+BuffField[N-1];
 inc(k);

 //new:
 if k = F_BackNum then
 begin
  F_BackPos:=N;
  F_BackPoint:=Pt;
  for i:=0 to 8 do
  for j:=0 to 8 do
  begin
   BackField[i,j]:=Field[i,j];
  end;
 end;


end;

//new:
if F_BackNum < 0 then begin F_BackNum:=0; F_BackPos:=F_BPos; end;


Preview[0]:=DUS[p-3];
Preview[1]:=DUS[p-2];
Preview[2]:=DUS[p-1];
F_Points:=Pt;
F_Pos:=N;
F_CurrentField:=F_NumberFields;
ShowField;
ShowPreview;
PP.Caption:=IntToStr(F_Points);

Back.Enabled:=True;
Right.Enabled:=False;



endp:
end;


(*
procedure TFrmGl.ReadField(Name: String);
var
i,j,n,k: Integer;
f: file of Integer;
size: Cardinal;
Buff: array of Integer;
FileHandle,Pt,L: Integer;
Pm: ^Integer;
begin

AssignFile(f, Name);
Reset(f);
size := FileSize(f);
CloseFile(F);


SetLength(Buff,size);
FileHandle := FileOpen(Name, fmOpenRead);
FileRead(FileHandle, Buff[0], Length(Buff)*4);
FileClose(FileHandle);





SetLength(WField,Trunc(size/85));//*4 - in byte

n:=0;
for i:=0 to High(WField) do
begin
WField[i].Points:=Buff[n];
inc(n);
end;

for i:=0 to High(WField) do
begin
  for j:=0 to 2 do
  begin
   WField[i].Preview[j]:=Buff[n];
   inc(n);
  end;
end;


for i:=0 to High(WField) do
begin
  for j:=0 to 8 do
  begin
   for k:=0 to 8 do
   begin
   WField[i].Field[j,k]:=Buff[n];
   inc(n);
  end;
 end;
end;


 for i:=0 to 8 do
 for j:=0 to 8 do
 begin
  Field[i,j]:=WField[High(WField)].Field[i,j];
 end;

 for i:=0 to 2 do
 begin
  Preview[i]:=WField[High(WField)].Preview[i];
 end;

 Buff:=nil;










 for i:=0 to 8 do
 for j:=0 to 8 do
 Field[i,j]:=0;


 SetLength(DUS,200);
 SetLength(BuffField,23);
 BuffField[0]:=76; BuffField[1]:=73; BuffField[2]:=78; BuffField[3]:=69;
 BuffField[4]:=83; BuffField[5]:=189; BuffField[6]:=83; BuffField[7]:=76;
 BuffField[8]:=9; BuffField[9]:=6; BuffField[10]:=3;
 Pm:=@BuffField[11];
 Pm^:=WField[0].Points;
 BuffField[15]:=3;


 SetLength(BuffS,12);
 k:=-1;
 for i:=0 to 8 do
 for j:=0 to 8 do
 begin
  if WField[0].Field[i,j] <> -1 then
  begin
   inc(k); BuffS[k]:=i;
   inc(k); BuffS[k]:=j;
   inc(k); BuffS[k]:=WField[0].Field[i,j]+1;
   Field[i,j]:=WField[0].Field[i,j]+1;
  end;
 end;

 BuffS[k+1]:=WField[0].Preview[0]+1;
 BuffS[k+2]:=WField[0].Preview[1]+1;
 BuffS[k+3]:=WField[0].Preview[2]+1;

 Preview[0]:=WField[0].Preview[0]+1;
 Preview[1]:=WField[0].Preview[1]+1;
 Preview[2]:=WField[0].Preview[2]+1;

 F_Pos:=16;
 Pack;
 BuffField[22]:=0;
 F_Pos:=23;
 BuffField[22]:=0;


 F_Points:=0;

 for i:=1 to High(WField) do
 begin
  CompareField(i-1,i,N,Pt);
  L:=Length(BuffS);

  if L/2 <> Trunc(L/2) then k:=L div 2 + 1 else k:=L div 2;
  SetLength(BuffField,F_Pos+k+2);

  BuffField[F_Pos]:=(L-3) div 3;
  inc(F_Pos);

  {btest}
  {if i = High(WField)-1 then
  begin
   for j:=0 to High(BuffS) do
   M1.Lines[j]:=IntToStr(BuffS[j]);
  end;}
  {etest}

  Pack;

  {btest}
  {if i = High(WField)-1 then
  begin
   Unpack(F_Pos-1);
   for j:=0 to F_Test do
   M2.Lines[j]:=IntToStr(DUS[j]);
  end;}
  {etest}

  F_Pos:=F_Pos+k;
  BuffField[F_Pos]:=Pt;
  inc(F_Pos);

  Preview[0]:=WField[i].Preview[0]+1;
  Preview[1]:=WField[i].Preview[1]+1;
  Preview[2]:=WField[i].Preview[2]+1;

  F_Points:=F_Points+Pt;
 end;



//F_Points:=Pt;
F_Pos:=N;
F_CurrentField:=Length(WField);
F_NumberFields:=Length(WField);

ShowField;
ShowPreview;
PP.Caption:=IntToStr(F_Points{WField[High(WField)].Points});
Back.Enabled:=True;

end;
*)




procedure TfrmGL.SBSaveClick(Sender: TObject);
begin
if SaveFile.Execute then
 begin
  WriteField(SaveFile.FileName+'.lns');
 end;
end;

procedure TfrmGL.SBLoadClick(Sender: TObject);
begin
if OpenFile.Execute then
 begin
  if OpenFile.FilterIndex = 1 then
  ReadField(OpenFile.FileName)
  else
  begin
   MessageBeep(MB_ICONHAND);
   MessageDlg('Wrong file type',mtError,[mbOk],0)
  end;
 end;
end;


{
procedure TFrmGl.IntToByte(N: Integer; var AB: TArrayB);
var
i,K,N1,j: Integer;
SI,S8,S9,S7,S6,S5,S4,S3,S2,S1: String;
begin
S7:='0000000'; S6:='000000'; S5:='00000'; S4:='0000'; S3:='000'; S2:='00'; S1:='0';
S8:='00000000'; S9:='000000000';
SI:=IntToStr(N);
case Length(SI) of
1:   SI:=S9+SI;
2:   SI:=S8+SI;
3:   SI:=S7+SI;
4:   SI:=S6+SI;
5:   SI:=S5+SI;
6:   SI:=S4+SI;
7:   SI:=S3+SI;
8:   SI:=S2+SI;
9:   SI:=S1+SI;
end;

SetLength(AB,5);
AB[0]:=StrToInt(Copy(SI,1,2));
AB[1]:=StrToInt(Copy(SI,3,2));
AB[2]:=StrToInt(Copy(SI,5,2));
AB[3]:=StrToInt(Copy(SI,7,2));
AB[4]:=StrToInt(Copy(SI,9,2));

end;




function TFrmGl.ByteToInt(Buff: TArrayB; i: Integer): Integer;
var
SI: String;
begin
SI:=IntToStr(Buff[i])+IntToStr(Buff[i+1])+IntToStr(Buff[i+2])+IntToStr(Buff[i+3])+IntToStr(Buff[i+4]);
 ByteToInt:=StrToInt(SI);
end;
}










procedure TFrmGl.CompareField(i,j: Integer; var N,Pt: Integer);
var
m,k,l: Integer;
begin

l:=0;
for m:=0 to 8 do
 begin
  for k:=0 to 8 do
   begin
   if WField[i].Field[m,k] <> WField[j].Field[m,k] then
   begin
    DUS[l]:=m; DUS[l+1]:=k; DUS[l+2]:=WField[j].Field[m,k]+1; l:=l+3;
     Field[m,k]:=WField[j].Field[m,k]+1;
   end;
  end;
end;


DUS[l]:=WField[j].Preview[0]+1; inc(l);
DUS[l]:=WField[j].Preview[1]+1; inc(l);
DUS[l]:=WField[j].Preview[2]+1; inc(l);

SetLength(BuffS,l);
for m:=0 to l-1 do BuffS[m]:=DUS[m];

N:=l;
Pt:=WField[j].Points-WField[i].Points;
end;




procedure TfrmGl.TestPack_Unpack;
var
b1,b2,m: byte;
begin
 b1:=12; b2:=15;
 asm
  push  ax
  push  bx
  xor   ax,ax
  xor   bx,bx

  mov   bl,b2
  mov   al,b1
  shl   bx,12
  shrd  bx,ax,12
  mov   m,bl

  xor   ax,ax
  xor   bx,bx

  mov   al,m
  shrd  bx,ax,4
  shr   ax,4
  shr   bx,12
  mov   b1,al
  mov   b2,bl

  pop   bx
  pop   ax
 end;




end;








end.


